<?php

namespace Drupal\classes_extractor;

use Drupal\Core\Plugin\DefaultPluginManager;

/**
 * Manages discovery and instantiation of Classes Extractor plugins.
 */
class ClassesExtractorPluginManager extends DefaultPluginManager {

  /**
   * Constructs a new ClassesExtractorPluginManager object.
   *
   * @param string $namespace
   *   The namespace where plugins are found.
   * @param \Drupal\Core\Cache\CacheBackendInterface $cache_backend
   *   Cache backend instance to use.
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   *   The module handler to invoke the alter hook with.
   */
  public function __construct($namespace, $cache_backend, $module_handler) {
    // Specify the plugin's namespace, annotation type, and alter hooks.
    parent::__construct(
      'Plugin/ClassesExtractor',
      $namespace,
      $module_handler,
      'Drupal\classes_extractor\ClassesExtractorPluginInterface',
      'Drupal\classes_extractor\Annotation\ClassesExtractor'
    );

    // Use cache for plugin definitions.
    $this->setCacheBackend($cache_backend, 'classes_extractor_plugins');
  }

}
