<?php

namespace Drupal\classes_extractor\Controller;

use Drupal\Core\Cache\CacheableJsonResponse;
use Drupal\Core\Cache\CacheableMetadata;
use Drupal\Core\Controller\ControllerBase;

/**
 * Class ClassesExtractorController.
 *
 * Controller to show all classes on the backend.
 */
class ClassesExtractorController extends ControllerBase {

  /**
   * Gets all used classes.
   */
  public function getClasses() {
    $cacheable_metadata = new CacheableMetadata();
    $classes_extractor_manager = \Drupal::service('classes_extractor.manager');
    $cache = new CacheableJsonResponse([
      'classes' => $classes_extractor_manager->getAllClasses(),
    ]);
    $cache->addCacheableDependency($cacheable_metadata);
    return $cache;
  }

}
