<?php

namespace Drupal\classes_extractor\Drush;

use Drush\Commands\DrushCommands;

/**
 * Drush command to create a file in Drupal.
 */
class ClassesExtractorCommands extends DrushCommands {

  /**
   * Create a simple text file via Drush.
   *
   * @command class_extractor:create
   * @aliases cec
   */
  public function ExtractClasses() {
    $config = \Drupal::config('classes_extractor.configform');
    $classes_extractor_manager = \Drupal::service('classes_extractor.manager');
    $classes = $classes_extractor_manager->getAllClasses();
    $file_path = $config->get('file_path');
    file_put_contents($file_path, $classes);
    $this->output()->writeln("Classes successfully imported into the file. " . $file_path);
    \Drupal::logger('classes_extractor')->info('Classes successfully imported into the file' . $file_path);
  }

}
