<?php

namespace Drupal\classes_extractor\Plugin\ClassesExtractor;

use Drupal\classes_extractor\ClassesExtractorBase;

/**
 * Provides a DS Classes Extractor plugin.
 *
 * @ClassesExtractor(
 *   id = "ds_classes_extractor",
 *   label = @Translation("DS Classes Extractor")
 * )
 */
class DsClassesExtractor extends ClassesExtractorBase {

  /**
   * {@inheritdoc}
   */
  public function getClasses(): array {
    $classes = [];
    $dsSettings = \Drupal::config('ds.settings');
    $globalClasses = $dsSettings->get('classes') ?? [];
    $classes = array_merge($classes, $globalClasses['region'] ?? [], $globalClasses['field'] ?? []);
    return $classes;
  }

}
