<?php

namespace Drupal\classes_extractor\Plugin\ClassesExtractor;

use Drupal\classes_extractor\ClassesExtractorBase;
use Drupal\filter\Entity\FilterFormat;

/**
 * Provides a Editor Formatter Classes Extractor plugin.
 *
 * @ClassesExtractor(
 *   id = "editor_formatter_classes_extractor",
 *   label = @Translation("Editor Formatter Classes Extractor")
 * )
 */
class EditorFormatterClassesExtractor extends ClassesExtractorBase {

  /**
   * {@inheritdoc}
   */
  public function getClasses(): array {
    $classes = [];
    $filterFormat = FilterFormat::load('basic_editor');
    $filterHtml = $filterFormat->filters('filter_html');
    $config = $filterHtml->getConfiguration();
    if (!empty($config['settings']['allowed_html'])) {
      preg_match_all('/class="([^"]*)"/', $config['settings']['allowed_html'], $matches);
      if (!empty($matches[1])) {
        foreach ($matches[1] as $match) {
          $classes = array_merge($classes, explode(' ', $match));
        }
      }
    }
    return $classes;
  }

}
